Index: code/branches/cpp11_v3/src/libraries/core/config/ConfigFileManager.h
===================================================================
--- code/branches/cpp11_v3/src/libraries/core/config/ConfigFileManager.h	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/core/config/ConfigFileManager.h	(revision 11054)
@@ -38,5 +38,5 @@
 #include "core/CorePrereqs.h"
 
-#include <boost/array.hpp>
+#include <array>
 
 #include "util/Singleton.h"
@@ -67,7 +67,9 @@
 
         private:
-            ConfigFileManager(const ConfigFileManager&);    ///< Copy-constructor: not implemented
+            // non-copyable:
+            ConfigFileManager(const ConfigFileManager&) = delete;
+            ConfigFileManager& operator=(const ConfigFileManager&) = delete;
 
-            boost::array<ConfigFile*, 3> configFiles_;      ///< Stores the config files for each type in an array (must have the same size like ConfigFileType::Value)
+            std::array<ConfigFile*, 3> configFiles_;        ///< Stores the config files for each type in an array (must have the same size like ConfigFileType::Value)
             static ConfigFileManager* singletonPtr_s;       ///< Stores the singleton-pointer
     };
Index: code/branches/cpp11_v3/src/libraries/core/config/ConfigFileSection.cc
===================================================================
--- code/branches/cpp11_v3/src/libraries/core/config/ConfigFileSection.cc	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/core/config/ConfigFileSection.cc	(revision 11054)
@@ -80,8 +80,8 @@
     {
         unsigned int size = 0;
-        for (std::list<ConfigFileEntry*>::const_iterator it = this->entries_.begin(); it != this->entries_.end(); ++it)
-            if ((*it)->getName() == name)
-                if ((*it)->getIndex() >= size)
-                    size = (*it)->getIndex() + 1;
+        for (ConfigFileEntry* entry : this->entries_)
+            if (entry->getName() == name)
+                if (entry->getIndex() >= size)
+                    size = entry->getIndex() + 1;
         return size;
     }
@@ -99,5 +99,5 @@
 
     /**
-        @brief Returns the entry with given name (or NULL if it doesn't exist).
+        @brief Returns the entry with given name (or nullptr if it doesn't exist).
 
         @param name     The name of the entry
@@ -105,14 +105,14 @@
     ConfigFileEntry* ConfigFileSection::getEntry(const std::string& name) const
     {
-        for (std::list<ConfigFileEntry*>::const_iterator it = this->entries_.begin(); it != this->entries_.end(); ++it)
+        for (ConfigFileEntry* entry : this->entries_)
         {
-            if ((*it)->getName() == name)
-                return *it;
+            if (entry->getName() == name)
+                return entry;
         }
-        return NULL;
+        return nullptr;
     }
 
     /**
-        @brief Returns the entry of a vector element with given name and index (or NULL if it doesn't exist).
+        @brief Returns the entry of a vector element with given name and index (or nullptr if it doesn't exist).
 
         @param name     The name of the vector
@@ -121,10 +121,10 @@
     ConfigFileEntry* ConfigFileSection::getEntry(const std::string& name, unsigned int index) const
     {
-        for (std::list<ConfigFileEntry*>::const_iterator it = this->entries_.begin(); it != this->entries_.end(); ++it)
+        for (ConfigFileEntry* entry : this->entries_)
         {
-            if (((*it)->getName() == name) && ((*it)->getIndex() == index))
-                return *it;
+            if ((entry->getName() == name) && (entry->getIndex() == index))
+                return entry;
         }
-        return NULL;
+        return nullptr;
     }
 
Index: code/branches/cpp11_v3/src/libraries/core/config/ConfigValueContainer.cc
===================================================================
--- code/branches/cpp11_v3/src/libraries/core/config/ConfigValueContainer.cc	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/core/config/ConfigValueContainer.cc	(revision 11054)
@@ -53,5 +53,5 @@
         this->sectionname_ = sectionname;
         this->varname_ = varname;
-        this->callback_ = 0;
+        this->callback_ = nullptr;
         this->bContainerIsNew_ = true;
         this->bDoInitialCallback_ = false;
@@ -191,5 +191,5 @@
                 for (unsigned int i = this->valueVector_.size(); i <= index; i++)
                 {
-                    this->valueVector_.push_back(MultiType());
+                    this->valueVector_.emplace_back();
                 }
             }
Index: code/branches/cpp11_v3/src/libraries/core/config/ConfigValueContainer.h
===================================================================
--- code/branches/cpp11_v3/src/libraries/core/config/ConfigValueContainer.h	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/core/config/ConfigValueContainer.h	(revision 11054)
@@ -59,5 +59,5 @@
         public:
             virtual void call(void* object) = 0;
-            inline virtual ~ConfigValueCallbackBase() {}
+            virtual inline ~ConfigValueCallbackBase() {}
     };
 
@@ -67,6 +67,6 @@
         public:
             inline ConfigValueCallback(void (T::*function) (void)) : function_(function) {}
-            inline virtual ~ConfigValueCallback() {}
-            inline virtual void call(void* object)
+            virtual inline ~ConfigValueCallback() = default;
+            virtual inline void call(void* object) override
             {
                 if (!IdentifierManager::getInstance().isCreatingHierarchy())
@@ -130,6 +130,6 @@
 
                 this->value_ = V();
-                for (unsigned int i = 0; i < defvalue.size(); i++)
-                    this->valueVector_.push_back(MultiType(defvalue[i]));
+                for (const D& defvalueElement : defvalue)
+                    this->valueVector_.emplace_back(defvalueElement);
 
                 this->initVector();
@@ -183,6 +183,6 @@
                     std::vector<T> temp = *value;
                     value->clear();
-                    for (unsigned int i = 0; i < this->valueVector_.size(); ++i)
-                        value->push_back(this->valueVector_[i]);
+                    for (const MultiType& vectorEntry : this->valueVector_)
+                        value->push_back(vectorEntry);
 
                     if (value->size() != temp.size())
@@ -211,6 +211,6 @@
                 {
                     value->clear();
-                    for (unsigned int i = 0; i < this->valueVector_.size(); ++i)
-                        value->push_back(this->valueVector_[i]);
+                    for (const MultiType& vectorEntry : this->valueVector_)
+                        value->push_back(vectorEntry);
                 }
                 return *this;
@@ -223,5 +223,5 @@
             inline const std::string& getSectionName() const
                 { return this->sectionname_; }
-            /// Returns the associated identifier (can be NULL).
+            /// Returns the associated identifier (can be nullptr).
             inline Identifier* getIdentifier() const
                 { return this->identifier_; }
Index: code/branches/cpp11_v3/src/libraries/core/config/SettingsConfigFile.cc
===================================================================
--- code/branches/cpp11_v3/src/libraries/core/config/SettingsConfigFile.cc	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/core/config/SettingsConfigFile.cc	(revision 11054)
@@ -57,5 +57,5 @@
     SetConsoleCommand(__CC_getConfig_name,       &SettingsConfigFile::getConfig).argumentCompleter(0, autocompletion::settingssections()).argumentCompleter(1, autocompletion::settingsentries());
 
-    SettingsConfigFile* SettingsConfigFile::singletonPtr_s = 0;
+    SettingsConfigFile* SettingsConfigFile::singletonPtr_s = nullptr;
 
     /**
@@ -77,9 +77,9 @@
     SettingsConfigFile::~SettingsConfigFile()
     {
-        ModifyConsoleCommand(__CC_load_name).setObject(0);
-        ModifyConsoleCommand(__CC_setFilename_name).setObject(0);
-        ModifyConsoleCommand(__CC_config_name).setObject(0);
-        ModifyConsoleCommand(__CC_tconfig_name).setObject(0);
-        ModifyConsoleCommand(__CC_getConfig_name).setObject(0);
+        ModifyConsoleCommand(__CC_load_name).setObject(nullptr);
+        ModifyConsoleCommand(__CC_setFilename_name).setObject(nullptr);
+        ModifyConsoleCommand(__CC_config_name).setObject(nullptr);
+        ModifyConsoleCommand(__CC_tconfig_name).setObject(nullptr);
+        ModifyConsoleCommand(__CC_getConfig_name).setObject(nullptr);
     }
 
@@ -106,5 +106,5 @@
     void SettingsConfigFile::addConfigValueContainer(ConfigValueContainer* container)
     {
-        if (container == NULL)
+        if (container == nullptr)
             return;
         std::pair<std::string, ConfigValueContainer*> second(getLowercase(container->getName()), container);
@@ -118,5 +118,5 @@
     void SettingsConfigFile::removeConfigValueContainer(ConfigValueContainer* container)
     {
-        if (container == NULL)
+        if (container == nullptr)
             return;
         const std::string& sectionLC = getLowercase(container->getSectionName());
@@ -142,8 +142,8 @@
         // todo: can this be done more efficiently? looks like some identifiers will be updated multiple times.
 
-        for (ContainerMap::const_iterator it = this->containers_.begin(); it != this->containers_.end(); ++it)
-        {
-            it->second.second->update();
-            it->second.second->getIdentifier()->updateConfigValues();
+        for (const auto& mapEntry : this->containers_)
+        {
+            mapEntry.second.second->update();
+            mapEntry.second.second->getIdentifier()->updateConfigValues();
         }
     }
@@ -269,5 +269,5 @@
             {
                 std::string value;
-                it->second.second->getValue<std::string, void>(&value, NULL);
+                it->second.second->getValue<std::string, void>(&value, nullptr);
                 return value;
             }
Index: code/branches/cpp11_v3/src/libraries/core/config/SettingsConfigFile.h
===================================================================
--- code/branches/cpp11_v3/src/libraries/core/config/SettingsConfigFile.h	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/core/config/SettingsConfigFile.h	(revision 11054)
@@ -63,10 +63,10 @@
 
         public:
-            typedef std::multimap<std::string, std::pair<std::string, ConfigValueContainer*> > ContainerMap;
+            typedef std::multimap<std::string, std::pair<std::string, ConfigValueContainer*>> ContainerMap;
 
             SettingsConfigFile(const std::string& filename);
             ~SettingsConfigFile();
 
-            void load(); // tolua_export
+            virtual void load() override; // tolua_export
             void setFilename(const std::string& filename); // tolua_export
             void clean(bool bCleanComments = false); // tolua_export
Index: code/branches/cpp11_v3/src/libraries/core/input/Button.cc
===================================================================
--- code/branches/cpp11_v3/src/libraries/core/input/Button.cc	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/core/input/Button.cc	(revision 11054)
@@ -53,5 +53,5 @@
     Button::Button()
         : bButtonThresholdUser_(false)
-        , paramCommandBuffer_(0)
+        , paramCommandBuffer_(nullptr)
     {
         nCommands_[0]=0;
@@ -75,5 +75,5 @@
                     delete commands_[j][i];
                 delete[] commands_[j];
-                commands_[j] = 0;
+                commands_[j] = nullptr;
                 nCommands_[j] = 0;
             }
@@ -196,15 +196,15 @@
 
                     // add command to the buffer if not yet existing
-                    for (unsigned int iParamCmd = 0; iParamCmd < paramCommandBuffer_->size(); iParamCmd++)
-                    {
-                        if ((*paramCommandBuffer_)[iParamCmd]->evaluation_.getConsoleCommand()
+                    for (BufferedParamCommand* command : *paramCommandBuffer_)
+                    {
+                        if (command->evaluation_.getConsoleCommand()
                             == eval.getConsoleCommand())
                         {
                             // already in list
-                            cmd->paramCommand_ = (*paramCommandBuffer_)[iParamCmd];
+                            cmd->paramCommand_ = command;
                             break;
                         }
                     }
-                    if (cmd->paramCommand_ == 0)
+                    if (cmd->paramCommand_ == nullptr)
                     {
                         cmd->paramCommand_ = new BufferedParamCommand();
@@ -239,5 +239,5 @@
             }
             else
-                commands_[j] = 0;
+                commands_[j] = nullptr;
         }
     }
Index: code/branches/cpp11_v3/src/libraries/core/input/HalfAxis.h
===================================================================
--- code/branches/cpp11_v3/src/libraries/core/input/HalfAxis.h	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/core/input/HalfAxis.h	(revision 11054)
@@ -49,5 +49,5 @@
             : relVal_(0.0f)
             , absVal_(0.0f)
-            , paramCommands_(0)
+            , paramCommands_(nullptr)
             , nParamCommands_(0)
             , pressed_(false)
@@ -56,6 +56,6 @@
         using Button::execute;
         bool execute();
-        bool addParamCommand(ParamCommand* command);
-        void clear();
+        virtual bool addParamCommand(ParamCommand* command) override;
+        virtual void clear() override;
         void reset();
 
Index: code/branches/cpp11_v3/src/libraries/core/input/InputBuffer.cc
===================================================================
--- code/branches/cpp11_v3/src/libraries/core/input/InputBuffer.cc	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/core/input/InputBuffer.cc	(revision 11054)
@@ -75,7 +75,6 @@
     InputBuffer::~InputBuffer()
     {
-        for (std::list<BaseInputBufferListenerTuple*>::const_iterator it = this->listeners_.begin();
-            it != this->listeners_.end(); ++it)
-            delete *it;
+        for (BaseInputBufferListenerTuple* listener : this->listeners_)
+            delete listener;
     }
 
@@ -110,10 +109,10 @@
     void InputBuffer::insert(const std::string& input, bool update)
     {
-        for (unsigned int i = 0; i < input.size(); ++i)
-        {
-            this->insert(input[i], false);
+        for (const char& inputChar : input)
+        {
+            this->insert(inputChar, false);
 
             if (update)
-                this->updated(input[i], false);
+                this->updated(inputChar, false);
         }
 
@@ -170,8 +169,8 @@
     void InputBuffer::updated()
     {
-        for (std::list<BaseInputBufferListenerTuple*>::iterator it = this->listeners_.begin(); it != this->listeners_.end(); ++it)
-        {
-            if ((*it)->bListenToAllChanges_)
-                (*it)->callFunction();
+        for (BaseInputBufferListenerTuple* listener : this->listeners_)
+        {
+            if (listener->bListenToAllChanges_)
+                listener->callFunction();
         }
     }
@@ -179,8 +178,8 @@
     void InputBuffer::updated(const char& update, bool bSingleInput)
     {
-        for (std::list<BaseInputBufferListenerTuple*>::iterator it = this->listeners_.begin(); it != this->listeners_.end(); ++it)
-        {
-            if ((!(*it)->trueKeyFalseChar_) && ((*it)->bListenToAllChanges_ || ((*it)->char_ == update)) && (!(*it)->bOnlySingleInput_ || bSingleInput))
-                (*it)->callFunction();
+        for (BaseInputBufferListenerTuple* listener : this->listeners_)
+        {
+            if ((!listener->trueKeyFalseChar_) && (listener->bListenToAllChanges_ || (listener->char_ == update)) && (!listener->bOnlySingleInput_ || bSingleInput))
+                listener->callFunction();
         }
     }
@@ -201,8 +200,8 @@
             return;
 
-        for (std::list<BaseInputBufferListenerTuple*>::iterator it = this->listeners_.begin(); it != this->listeners_.end(); ++it)
-        {
-            if ((*it)->trueKeyFalseChar_ && ((*it)->key_ == evt.getKeyCode()))
-                (*it)->callFunction();
+        for (BaseInputBufferListenerTuple* listener : this->listeners_)
+        {
+            if (listener->trueKeyFalseChar_ && (listener->key_ == evt.getKeyCode()))
+                listener->callFunction();
         }
 
Index: code/branches/cpp11_v3/src/libraries/core/input/InputBuffer.h
===================================================================
--- code/branches/cpp11_v3/src/libraries/core/input/InputBuffer.h	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/core/input/InputBuffer.h	(revision 11054)
@@ -47,5 +47,5 @@
               trueKeyFalseChar_(trueKeyFalseChar), char_(_char), key_(key)
         { }
-        virtual ~BaseInputBufferListenerTuple() { }
+        virtual ~BaseInputBufferListenerTuple() = default;
         virtual void callFunction() = 0;
         bool bListenToAllChanges_;
@@ -65,6 +65,6 @@
               listener_(listener), function_(function)
         { }
-        virtual ~InputBufferListenerTuple() { }
-        void callFunction()
+        virtual ~InputBufferListenerTuple() = default;
+        virtual void callFunction() override
         {
             (listener_->*function_)();
@@ -165,13 +165,13 @@
                 { if (this->cursor_ > 0) { --this->cursor_; } }
 
-            void buttonPressed(const KeyEvent& evt);
+            virtual void buttonPressed(const KeyEvent& evt) override;
 
         private:
             bool charIsAllowed(const char& input);
 
-            void buttonHeld   (const KeyEvent& evt);
-            void processKey   (const KeyEvent& evt);
+            virtual void buttonHeld (const KeyEvent& evt) override;
+            void processKey (const KeyEvent& evt);
 
-            void keyboardUpdated(float dt);
+            virtual void keyboardUpdated(float dt) override;
 
             std::string buffer_;
Index: code/branches/cpp11_v3/src/libraries/core/input/InputCommands.h
===================================================================
--- code/branches/cpp11_v3/src/libraries/core/input/InputCommands.h	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/core/input/InputCommands.h	(revision 11054)
@@ -57,5 +57,5 @@
     public:
         BaseCommand() : bFixedKeybindMode_(false) {}
-        virtual ~BaseCommand() { }
+        virtual ~BaseCommand() = default;
 
         virtual bool execute(float abs = 1.0f, float rel = 1.0f) = 0;
@@ -76,7 +76,7 @@
     {
     public:
-        bool execute(float abs = 1.0f, float rel = 1.0f);
-        CommandEvaluation* getEvaluation();
-        virtual SimpleCommand* clone() { return new SimpleCommand(*this); }
+        virtual bool execute(float abs = 1.0f, float rel = 1.0f) override;
+        virtual CommandEvaluation* getEvaluation() override;
+        virtual SimpleCommand* clone() override { return new SimpleCommand(*this); }
 
         CommandEvaluation evaluation_;
@@ -103,8 +103,8 @@
     {
     public:
-        ParamCommand() : scale_(1.0f), paramCommand_(0) { }
-        bool execute(float abs = 1.0f, float rel = 1.0f);
-        CommandEvaluation* getEvaluation();
-        virtual ParamCommand* clone() { return new ParamCommand(*this); }
+        ParamCommand() : scale_(1.0f), paramCommand_(nullptr) { }
+        virtual bool execute(float abs = 1.0f, float rel = 1.0f) override;
+        virtual CommandEvaluation* getEvaluation() override;
+        virtual ParamCommand* clone() override { return new ParamCommand(*this); }
 
         float scale_;
@@ -118,5 +118,5 @@
             return &this->paramCommand_->evaluation_;
         else
-            return 0;
+            return nullptr;
     }
 }
Index: code/branches/cpp11_v3/src/libraries/core/input/InputDevice.h
===================================================================
--- code/branches/cpp11_v3/src/libraries/core/input/InputDevice.h	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/core/input/InputDevice.h	(revision 11054)
@@ -60,5 +60,5 @@
         //! Only resets the members
         InputDevice(unsigned int id) : bCalibrating_(false), deviceID_(id) { }
-        virtual ~InputDevice() { }
+        virtual ~InputDevice() = default;
         //! Returns the device class (derived) name as string
         virtual std::string getClassName() const = 0;
@@ -99,5 +99,7 @@
 
     private:
-        InputDevice(const InputDevice& rhs); //!< Don't use!
+        // non-copyable:
+        InputDevice(const InputDevice&) = delete;
+        InputDevice& operator=(const InputDevice&) = delete;
 
         bool bCalibrating_;                  //!< Whether the device is in calibration mode
@@ -153,17 +155,17 @@
 
         //! Captures OIS events (which then get distributed to the derived class) and creates the button held events
-        void update(const Clock& time)
+        virtual void update(const Clock& time) override
         {
             oisDevice_->capture();
 
             // Call all the states with the held button event
-            for (unsigned int iB = 0; iB < pressedButtons_.size(); ++iB)
-                for (unsigned int iS = 0; iS < inputStates_.size(); ++iS)
-                    inputStates_[iS]->buttonEvent<ButtonEvent::THold, typename Traits::ButtonTypeParam>(
-                        this->getDeviceID(), static_cast<DeviceClass*>(this)->getButtonEventArg(pressedButtons_[iB]));
+            for (ButtonType& button : pressedButtons_)
+                for (InputState* state : inputStates_)
+                    state->template buttonEvent<ButtonEvent::THold, typename Traits::ButtonTypeParam>(
+                        this->getDeviceID(), static_cast<DeviceClass*>(this)->getButtonEventArg(button));
 
             // Call states with device update events
-            for (unsigned int i = 0; i < inputStates_.size(); ++i)
-                inputStates_[i]->update(time.getDeltaTime(), this->getDeviceID());
+            for (InputState* state : inputStates_)
+                state->update(time.getDeltaTime(), this->getDeviceID());
 
             static_cast<DeviceClass*>(this)->updateImpl(time);
@@ -171,5 +173,5 @@
 
         //! Clears the list of pressed buttons and calls the derived class's method
-        void clearBuffers()
+        virtual void clearBuffers() override
         {
             pressedButtons_.clear();
@@ -180,5 +182,5 @@
         OISDeviceClass* getOISDevice()   { return this->oisDevice_; }
         // Returns the name of the derived class as string
-        std::string getClassName() const { return DeviceClass::getClassNameImpl(); }
+        virtual std::string getClassName() const override { return DeviceClass::getClassNameImpl(); }
 
     protected:
@@ -196,6 +198,6 @@
 
             // Call states
-            for (unsigned int i = 0; i < inputStates_.size(); ++i)
-                inputStates_[i]->buttonEvent<ButtonEvent::TPress, typename Traits::ButtonTypeParam>(this->getDeviceID(), static_cast<DeviceClass*>(this)->getButtonEventArg(button));
+            for (InputState* state : inputStates_)
+                state->template buttonEvent<ButtonEvent::TPress, typename Traits::ButtonTypeParam>(this->getDeviceID(), static_cast<DeviceClass*>(this)->getButtonEventArg(button));
         }
 
@@ -218,6 +220,6 @@
 
             // Call states
-            for (unsigned int i = 0; i < inputStates_.size(); ++i)
-                inputStates_[i]->buttonEvent<ButtonEvent::TRelease, typename Traits::ButtonTypeParam>(this->getDeviceID(), static_cast<DeviceClass*>(this)->getButtonEventArg(button));
+            for (InputState* state : inputStates_)
+                state->template buttonEvent<ButtonEvent::TRelease, typename Traits::ButtonTypeParam>(this->getDeviceID(), static_cast<DeviceClass*>(this)->getButtonEventArg(button));
         }
 
Index: code/branches/cpp11_v3/src/libraries/core/input/InputHandler.h
===================================================================
--- code/branches/cpp11_v3/src/libraries/core/input/InputHandler.h	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/core/input/InputHandler.h	(revision 11054)
@@ -119,5 +119,5 @@
     {
     public:
-        virtual ~InputHandler() { }
+        virtual ~InputHandler() = default;
 
         template<class T> void buttonEvent(unsigned int device, T button, ButtonEvent::TPress)
